import cmath
import pylab as pl

def affixe(l):
    X = []
    Y = []
    for i in range(len(l)):
        X.append(l[i][0])
        Y.append(l[i][1])
    return (X,Y)


def KochSegment(xa,ya,xb,yb):
    za=complex(xa,ya)
    zb=complex(xb,yb)
    zd=complex((xb-xa)*2/3+xa,(yb-ya)*2/3+ya)
    zc=complex((xb-xa)/3+xa,(yb-ya)/3+ya)
    ze=cmath.exp(3.1415926535897932j/3)
    ze=ze*(zd-zc)+zc
    return(za,zc,ze,zd,zb)
    
    
def KochGlobal(L):
    LT = []   #initialisation de la liste LT
    for i in range (0,len(L)-1): #i va de 0 à la taille de L -1
        xa = L[i][0]  #initialisation de chaque coordonnées des premiers points
        ya = L[i][1]
        xb = L[i+1][0]
        yb = L[i+1][1]
    
        za,zc,ze,zd,zb=KochSegment(xa,ya,xb,yb)
    
        LT.append([za.real,za.imag]) #On prend la partie réelle et imaginaire
        LT.append([zc.real,zc.imag]) #afin de constituer la liste voulue
        LT.append([ze.real,ze.imag])
        LT.append([zd.real,zd.imag])
        LT.append([zb.real,zb.imag])
    
    return(LT)      #retour de la liste finale
    

def KochGlobalit(L,n):
    for i in range(0,n):
        L=KochGlobal(L)
    return(L)

def KochCourbe(n):
    L=KochGlobalit([[0,0],[1,0]],n) #départ avec A(0,0) et B(0,0)
    (X,Y)=affixe(L) #Chaque coordonnées séparées
    pl.plot(X,Y)    #Affichage
    pl.show()
    return None

def KochFlocon(n):
    L=KochGlobalit([[0,0],[1,0]],n)   #Segment AB
    LL=KochGlobalit([[1,0],[0.5,-0.866025]],n)   #Segment BC
    LLL=KochGlobalit([[0.5,-0.866025],[0,0]],n)   #Segment CA
    (X,Y)=affixe(L)
    (XX,YY)=affixe(LL)
    (XXX,YYY)=affixe(LLL)
    X=X+XX+XXX
    Y=Y+YY+YYY
    pl.plot(X,Y)
    pl.show()
    return None
